'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _babelCore = require('babel-core');

var _fs = require('fs');

var _fs2 = _interopRequireDefault(_fs);

var _path = require('path');

var _path2 = _interopRequireDefault(_path);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var BabelCompiler = function () {
    function BabelCompiler(cwd, configs) {
        _classCallCheck(this, BabelCompiler);

        if (BabelCompiler.prototype.instance) return BabelCompiler.prototype.instance;
        BabelCompiler.prototype.instance = this;
        this.current = cwd;
        // get configuration from .babelrc, package.json or wxa.config.js
        this.configs = null;
        try {
            var babelrc = JSON.parse(_fs2.default.readFileSync(_path2.default.join(this.current, '.babelrc'), 'utf-8'));
            this.configs = babelrc;
        } catch (e) {
            var pkg = require(_path2.default.join(this.current, 'package.json'));
            this.configs = pkg.babel || null;
        }

        if (this.configs == null) this.configs = configs.babel || {};
    }

    _createClass(BabelCompiler, [{
        key: 'parse',
        value: function parse(content, configs) {
            console.info('compile with babel');
            if (configs == null) configs = this.configs;
            try {
                var rst = (0, _babelCore.transform)(content, configs);
                return Promise.resolve(rst);
            } catch (e) {
                return Promise.reject(e);
            }
        }
    }, {
        key: 'mount',
        value: function mount(map) {
            map['js'] = this;
            return map;
        }
    }]);

    return BabelCompiler;
}();

exports.default = BabelCompiler;